library transformer;

import 'dart:async';

abstract class Transformer implements EventSink, StreamTransformer {
  EventSink _sink;

  void handleData(event, EventSink sink);

  void handleError(error, EventSink sink, [StackTrace stackTrace]) {
    sink.addError(error, stackTrace);
  }

  void add(event) {
    handleData(event, _sink);
  }

  void addError(error, [StackTrace stackTrace]) {
    handleError(error, _sink, stackTrace);
  }

  void close() => _sink.close();

  Stream bind(Stream source) {
    var stream = new Stream.eventTransformed(source, (EventSink sink) {
      _sink = sink;
      return this;
    });

    return stream;
  }
}

